// Sortarea prin NUMARARE
// O(n + vmax) - time complexity
// O(n + vmax) - memory complexity 

// Cand vmax aproximativs egal cu n => O(n)  - time complexity
#include <fstream>
#include <algorithm>
using namespace std;

void Citeste(int a[], int& n, int& vmax);
void Numarare(int a[], int, int b[], int c[], int vmax); 
void Afiseaza(int*, int);

int main()
{
	int a[100], n; // sirul de sortat
	int b[100];    // sirul sortat
	int c[1000] = { 0 }, vmax = 0; // sirul auxiliar ( caracteristic)

	Citeste(a, n, vmax);
	Numarare(a, n, b, c, vmax);
	Afiseaza(b, n);

	return 0;
}

void Citeste(int* a, int& n, int& vmax)
{
	ifstream fin("sir.in");
	fin >> n;                       // fiecare elem al sirului a, trebuie sa fie un numar natural mic
	for ( int i = 1; i <= n; i++ )  // iar vmax = O(n)
    {
		fin >> a[i];
		vmax  = max(a[i], vmax);
    }

	fin.close();
}

void Afiseaza(int b[], int n )
{
	ofstream fout("sir.out");
	for ( int i = 1; i <= n; i++ )
		fout << b[i] << " ";

	fout.close();
}

void Numarare(int a[], int n, int b[], int c[], int vmax)  // O(n + vmax ) time complexity
{                                                          // O(n + vmax ) memory complexity

	for ( int j = 1; j <= n; j++ ) c[a[j]]++; // c[i] - numarul elem egale cu i (frecventele)

	for ( int i = 1; i <= vmax; i++ ) //  O(vmax)
		c[i] += c[i - 1];             // c[i] - numarul elem mai mici sau egale cu i

	for ( int j = n; j >= 1; j-- )    // O(n)
	{
		b[c[a[j]]] = a[j];
		c[a[j]]--;  // pt cazul cu elemente identice
	}
}







