// Sortarea prin Interclasare
// MERGE SORT 
// O(n * log n) - Time complexity
// O(2 * n)     - Memory complexity 
#include <fstream>
using namespace std;

int a[10000], n;  // sirul de sortat

void Read();
void Merge(int st, int dr);
void Interclass(int st, int m, int dr);
void Write();

int main()
{
	Read();
	Merge(0, n - 1);
	Write();

	return 0;
}

void Read()
{
	ifstream fin("sir.in");
	fin >> n;

	for ( int i = 0; i < n; i++ )
		fin >> a[i];

	fin.close();
}

void Interclass(int st, int m, int dr)
{
	int i, j, k;
	int tmp[10000];
	i = st; j = m + 1; k = 0;
	while (i <= m && j <= dr)
		if (a[i] < a[j])
			tmp[k++] = a[i++];
		else
			tmp[k++] = a[j++];

	while (i <= m)
		tmp[k++] = a[i++];

	while (j <= dr)
		tmp[k++] = a[j++];

	for (i = st; i <= dr; i++ )
		a[i] = tmp[i - st];
}

void Merge(int st, int dr)
{
	if (st >= dr) return;

	int m = (st + dr) / 2;
	Merge(st, m);      // sorteaza intervalaul a[st] ... a[m]
	Merge(m + 1, dr);  // sorteaza intervalaul a[m + 1] ... a[dr]
	Interclass(st, m, dr);

}

void Write()
{
	ofstream fout("sir.out");

	for(int i = 0; i < n; i++)
		fout << a[i] << " ";

	fout.close();
}

